import { Children, cloneElement, forwardRef } from 'react';
import PropTypes from 'prop-types';
import { jsx as _jsx } from "react/jsx-runtime";
var PopoverExtendChildren = /*#__PURE__*/forwardRef(function (_ref, targetRef) {
  var children = _ref.children;

  var onClickHandler = function onClickHandler(handler) {
    return function (ev) {
      typeof handler === 'function' && handler(ev);
    };
  };

  var childrenOnly = typeof children === 'string' ? [/*#__PURE__*/_jsx("span", {
    children: children
  }, 1)] : Children.only(children);
  var response = Children.map(childrenOnly, function (child, key) {
    var onClick = child.props.onClick;
    var attrs = {
      onClick: onClickHandler(onClick)
    };

    attrs.ref = function (node) {
      ;
      [child.ref, targetRef].forEach(function (ref) {
        if (typeof ref === 'function') {
          ref(node);
        } else if (ref !== null) {
          ref.current = node;
        }
      });
    };

    attrs.key = key;
    return /*#__PURE__*/cloneElement(child, attrs);
  });
  return response;
});
export default PopoverExtendChildren;